#ifndef EMUDEFS_H
#define EMUDEFS_H

#define MAX_INSTR_LENGTH 4
#define NUM_FLAGS 8
#define NUM_OPCODES 16
#define NUM_REGISTERS 8
#define INVALID_MEMORY_ADDRESS -1


/* OPCODES */
typedef enum {INVALID_OPCODE = -1, ADD=1, AND, BSF, BSR, BSWAP, DEC, DIV, HLT, INC, JA, JAE,
              JB, JBE, JC, JE, JG, JGE, JL, JLE, JMP, JNA, JNAE, JNB, JNBE, JNC, JNE, JNG, JNGE,
              JNL, JNLE, JNO, JNP, JNS, JNZ, JO, JP, JPO, JS, JZ, LOOP, LOOPE, LOOPNZ, LOOPNE, MOV,
              MUL, NEG, NOT, OR, POP, POPA, POPAD, POPF, POPFD, PUSH, PUSHA, PUSHAD, PUSHF, PUSHFD,
              SUB, SUBI, XOR} opcode_t;

/* REGISTERS */
typedef enum {INVALID_REGISTER = -1, R0, R1, R2, R3, R4, R5, R6, R7} register_t;

/* ADDRESSING MODES */
typedef enum {INVALID_ADDR_MODE = -1, REGISTER, IMMEDIATE, INDIRECT, INDEXED, DIRECT} address_mode_t;

/* BOOL TYPE */
typedef enum {TRUE, FALSE} bool_t;

typedef struct
{
    int size_ds;
    int size_cs;
} objfile_hdr;

typedef unsigned char byte;
typedef byte instruction[MAX_INSTR_LENGTH];

#endif
