#ifndef EMULATOR_H
#define EMULATOR_H
/* PROCESS STATES*/
#define STOPPED 0
#define RUNNING 1
#define WAITING 2
#define READY 3
#include "emudefs.h"

void SUB(short* dest, short* src);
void DEC(short* dest);
void INC(short* dest);
void NOT(short* dest);
void XOR(short* dest, short* src);
void OR(short* dest, short* src);
void AND(short* dest, short* src);
void ADD(short* dest, short* src);

typedef enum {WAITING, RUNNING, STOPPED} proc_state_t;

struct process
{
    byte state;
    short registers[NUM_REGISTERS];
    short flags[NUM_FLAGS];
    short IP;
    int PID;
    byte* DS;
    byte* CS;
    struct process* next;
};

typedef struct process process;

typedef struct
{
    process* first_process;
    process* curr_process;
    process* last_process;
    int num_curr_processes;
} proc_table;


#endif